Leetcode 3 Longest Substring without Repeating Characters


Longest Substring without repeating characters

Question

Given a string, find the length of the longest substring without repeating characters.

Example 1:

Input: "abcabcbb"
Output: 3
Explanation: The answer is "abc", with the length of 3.

Example 2:

Input: "bbbbb"
Output: 1
Explanation: The answer is "b", with the length of 1.

Example 3:

Input: "pwwkew"
Output: 3
Explanation: The answer is "wke", with the length of 3.
            Note that the answer must be a substring, "pwke" is a subsequence and not a substring.

 

 

Naïve solution: brute force

The idea is to check every substring of the string, and use a set to check if the substring contains duplicate.

class Solution
{
public:
int lengthOfLongestSubstring(string s)
{
int i, j, k;
int longest = 0;
      for (i = 0; i<s.length() - 1; i++)
          for (j = i + 1; j<s.length(); j++)
          {
              set<char> substring;
              for (k = i; k <= j; k++)
              {
                  if (substring.find(s[k]) != substring.end())
                  {
                      longest = max(longest, int(substring.size()));
                      break;
                  }
                  else
                      substring.insert(s[k]);
              }
              //这个小心! e.g. "pwwkew"
              longest = max(longest, int(substring.size()));
          }

return longest;
}
};

Sliding Window

A window is represented by $​[x,y)$, containing a substring.

The idea is to use a sliding window to store the characters in current window, if s[j] is not in the set, then slide j further. Otherwise we find the maximum size of the current substring starting from i. Repeat for a new i.

class Solution 
{
public:
  int lengthOfLongestSubstring(string s)
  {
      int i=0, j=0;
      int longest = 0;
      unordered_map <char, int> characters;

      while( i<s.length() && j<s.length() )
      {
          if(characters.find(s[j])==characters.end() || characters[s[j]]<i || characters[s[j]]>=j)
          {
              //此时map种没有这个值或者位置在window之外
              characters[s[j]] = j;
              j++;
          }
          else
          {
              if((j-i)>longest)
                  longest = j-i;
              i = characters[s[j]]+1;
              j = i;
          }
      }

      if((j-i)>longest)
          longest = j-i;

      return longest;
  }
};

 

posted @ 2019-05-31 23:19  jenny1000000  阅读(91)  评论(0编辑  收藏  举报